package totaylor;

import java.util.HashMap;
import java.util.Map;

import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.core.config.CoreQueueConfiguration;
import org.hornetq.core.config.impl.ConfigurationImpl;
import org.hornetq.core.remoting.impl.invm.InVMAcceptorFactory;
import org.hornetq.core.remoting.impl.netty.NettyAcceptorFactory;
import org.hornetq.core.remoting.impl.netty.TransportConstants;
import org.hornetq.core.server.HornetQServer;
import org.hornetq.core.server.HornetQServers;
import org.hornetq.core.server.JournalType;

public class Node2 {

    static final String ADDRESS = "192.168.1.144";
    static final int PORT = 23456;

    public static void main(String[] args) {
        ConfigurationImpl cfg = new ConfigurationImpl();

        // acceptors (local addr: 192.168.1.144:2356)
        Map<String, Object> params = new HashMap<String, Object>();
        params.put(TransportConstants.HOST_PROP_NAME, ADDRESS);
        params.put(TransportConstants.PORT_PROP_NAME, PORT);
        TransportConfiguration nettyTransport = new TransportConfiguration(NettyAcceptorFactory.class.getName(), params, "hello-acceptor");
        cfg.getAcceptorConfigurations().add(nettyTransport);
        cfg.getAcceptorConfigurations().add(new TransportConfiguration(InVMAcceptorFactory.class.getName()));

        // dir settings
        cfg.setJournalDirectory("g:/temp/node2/journal");
        cfg.setLargeMessagesDirectory("g:/temp/node2/lm");
        cfg.setBindingsDirectory("g:/temp/node2/bindings");

        // queues
        CoreQueueConfiguration queue1 = new CoreQueueConfiguration("queue1", "queue1", null, true);
        cfg.getQueueConfigurations().add(queue1);

        // others
        cfg.setPersistenceEnabled(true);
        cfg.setJournalType(JournalType.NIO);
        cfg.setSecurityEnabled(false);

        HornetQServer hqserver = HornetQServers.newHornetQServer(cfg);
        try {
            hqserver.start();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
